Imports Fitter

Public Class MainForm
    Dim WithEvents Fitter As DMFitter

    Private Sub CloseButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CloseButton.Click
        Close()
    End Sub

    Private Sub FitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FitButton.Click
        Dim X(99) As Double, Y(99) As Double, I, Par(3) As Double, Sig(3) As Double
        Dim Opt(2) As Double

        ' create fitting data
        For I = 0 To UBound(X)
            X(I) = I
            Y(I) = 0.123 + 3.456 * I - 0.345 * I ^ 2 + 0.00567 * I ^ 3
        Next

        ' initialize parameter arrays
        For I = 0 To UBound(Par)
            Par(I) = 1
        Next
        For I = 0 To UBound(Sig)
            Sig(I) = 0
        Next
        Opt(0) = 0.0000001
        Opt(1) = 0.0000001
        Opt(2) = 0

        ' initialize fitter
        Fitter.X = X
        Fitter.Y = Y
        If ParserRadioButton.Checked Then
            Fitter.Expression = "p1+p2*cx+p3*cx^2+p4*cx^3"
        Else
            Fitter.Expression = -1 ' <- means using both events
            If FuncRadioButton.Checked Then
                Fitter.Expression = -2 ' <- means using ONLY OnGetLMFunction
            End If
        End If
        Fitter.ParamCount = 4
        Fitter.Parameters = Par
        Fitter.Sigmas = Sig
        Fitter.WeightType = 0
        Fitter.Options = Opt
        Fitter.Iterations = 50

        ' fitting
        If Fitter.LMFit Then
            MsgBox("Deviation: " & Fitter.Deviation & _
              vbCrLf & "Result code: " & Fitter.ResultCode)
        Else
            MsgBox("Error code: " & Fitter.ResultCode)
        End If
    End Sub

    Private Sub MainForm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        'MsgBox(TypeName(Fitter))
        Fitter = New DMFitter
        'MsgBox(TypeName(Fitter))
    End Sub

    Private Sub Fitter_OnProgress() Handles Fitter.OnProgress
        Dim I, Par
        ParametersListBox.Items.Clear()
        Par = Fitter.Parameters
        For I = 0 To UBound(Par)
            ParametersListBox.Items.Add("P" & I + 1 & "=" & Par(I))
        Next
        ParametersListBox.Refresh()
    End Sub

    Private Function Fitter_OnGetLMFunction(ByVal X As Double, _
      ByVal Parameters As Object) As Double Handles Fitter.OnGetLMFunction
        Fitter_OnGetLMFunction = Parameters(0) + Parameters(1) * X + _
          Parameters(2) * X ^ 2 + Parameters(3) * X ^ 3
    End Function

    Private Function Fitter_OnGetLMDerivative(ByVal X As Double, _
      ByVal Parameters As Object, ByVal Sigmas As Object) As Object _
      Handles Fitter.OnGetLMDerivative
        Dim A(3) As Double
        A(0) = 1
        A(1) = X
        A(2) = X ^ 2
        A(3) = X ^ 3
        Fitter_OnGetLMDerivative = A
    End Function

End Class
