' This script invokes LinearFit member of DMApplication object
' or DMFitter object. Both methods return the same and must 
' be invoked from the DM2003 Script Editor.

sub TestIDMApplicationLinearFit
dim X(99), Y(99), I, Solution, Deviation, ResCode
  ' create fitting data
  for I=0 to UBound(X)
    X(I)=I
    Y(I)=0.123+3.456*I-0.345*I^2+0.00567*I^3
  next
  Server.LinearFit X, Y, 4, 0, Solution, Deviation, ResCode
  Server.Notes.AddLine "==================================="
  Server.Notes.AddLine "ResCode: " & ResCode
  Server.Notes.AddLine "Deviation: " & Deviation
  if not IsArray(Solution) then exit sub
  for I=0 to UBound(Solution)
    Server.Notes.AddLine "Solution(" & I+1 & "): " & Solution(I)
  next
end sub

sub TestDMFitterLinearFit 
dim X(99), Y(99), I, Fitter, P
  ' create fitting data
  for I=0 to UBound(X)
    X(I)=I
    Y(I)=0.123+3.456*I-0.345*I^2+0.00567*I^3
  next
  ' create and initialize fitter
  set Fitter=CreateObject("Fitter.DMFitter")
  Fitter.X=X
  Fitter.Y=Y
  Fitter.Expression=0 ' polynomial basis
  Fitter.ParamCount=4
  if Fitter.LinearFit then
    Server.Notes.AddLine "==================================="
    Server.Notes.AddLine "Fitter.ResultCode: " & Fitter.ResultCode
    Server.Notes.AddLine "Fitter.Deviation: " & Fitter.Deviation
    P=Fitter.Parameters
    for I=0 to UBound(P)
      Server.Notes.AddLine "Fitter.Parameters(" & I & "): " & P(I)
    next
  end if
end sub
