program TestLMFit;
(*
This Delphi application is a very close translation
of VBScript code from TestLMFit.htm sample
*)

{$APPTYPE CONSOLE}

uses
  SysUtils, COMObj, Variants, ActiveX, Windows;

var
  X,Y,P,S,O,Fitter: variant;
  I: integer;
  Buffer: array[0..1024] of char;

const
  VectorSize=100;
  ParamCount=4;
  
begin
  { TODO -oUser -cConsole Main : Insert code here }
  writeln('This application invokes DMFitter.LMFit()');
  writeln('Following expression will be fitted:');
  writeln('0.123+3.456*I-0.345*I*I+0.00567*I*I*I');
  writeln;
  // prepare fitting data
  X:=VarArrayCreate([0, VectorSize-1], varVariant);
  Y:=VarArrayCreate([0, VectorSize-1], varVariant);
  for I:=0 to VectorSize-1 do
  begin
    X[I]:=I;
    Y[I]:=0.123+3.456*I-0.345*I*I+0.00567*I*I*I;
  end;
  // initialize parameters and fix flags
  P:=VarArrayCreate([0, ParamCount-1], varVariant);
  S:=VarArrayCreate([0, ParamCount-1], varVariant);
  for I:=0 to ParamCount-1 do // as in TestLMFit.htm...
  begin
    P[I]:=1;
    S[I]:=0;
  end;
  // initialize fitter options
  O:=VarArrayCreate([0, 2], varVariant);
  O[0]:=1e-7; // Parameters convergence threshold
  O[1]:=1e-7; // Chi^2 convergence threshold
  O[2]:=0; // derivative dX
  // create and initialize fitter object
  OleInitialize(nil);
  try
    Fitter:=CreateOLEObject('Fitter.DMFitter');
  except
    on E: Exception do
    begin
      writeln('Unable to create <Fitter.DMFitter>!');
      StrPCopy(Buffer, E.Message);
      ANSIToOem(Buffer,Buffer); // convert codepage for console
      writeln(Buffer);
      writeln('Click <ENTER> to close');
      readln;
      halt;
    end;
  end;
  Fitter.Expression:='p1+p2*cx+p3*cx^2+p4*cx^3'; // polynomial fitting
  Fitter.ParamCount:=ParamCount; // number of terms in the polynom
  Fitter.X:=X;
  Fitter.Y:=Y;
  Fitter.Parameters:=P;
  Fitter.Sigmas:=S;
  Fitter.Iterations:=30;
  Fitter.Options:=O; // <- this step is optional
  Fitter.WeightType:=0; // <- this step is optional
  // run fitting
  if Fitter.LMFit then
  begin // print results
    writeln('Fitter.ResultCode: ', Fitter.ResultCode);
    writeln('Fitter.Deviation: ', Fitter.Deviation);
    writeln('Fitter.Iterations: ', Fitter.Iterations);
    P:=Fitter.Parameters;
    for I:=0 to Fitter.ParamCount-1 do
    writeln('Parameters[', I, ']=', P[I]);
  end else
    writeln('Fitting error #', Fitter.ResultCode);
  // wait to close application
  writeln('Click <ENTER> to close');
  readln;
end.
