program TestLinearFit;
(*
This Delphi application is a very close translation
of VBScript code from TestLinearFit.htm sample
*)

{$APPTYPE CONSOLE}

uses
  SysUtils, COMObj, Variants, ActiveX, Windows;

var
  X,Y,P,Fitter: variant;
  I: integer;
  Buffer: array[0..1024] of char;

const
  VectorSize=100;

begin
  { TODO -oUser -cConsole Main : Insert code here }
  writeln('This application invokes DMFitter.LinearFit()');
  writeln('Following expression will be fitted:');
  writeln('0.123+3.456*I-0.345*I*I+0.00567*I*I*I');
  writeln;
  // prepare fitting data
  X:=VarArrayCreate([0, VectorSize-1], varVariant);
  Y:=VarArrayCreate([0, VectorSize-1], varVariant);
  for I:=0 to VectorSize-1 do
  begin
    X[I]:=I;
    Y[I]:=0.123+3.456*I-0.345*I*I+0.00567*I*I*I;
  end;
  // create and initialize fitter object
  OleInitialize(nil);
  try
    Fitter:=CreateOLEObject('Fitter.DMFitter');
  except
    on E: Exception do
    begin
      writeln('Unable to create <Fitter.DMFitter>!');
      StrPCopy(Buffer, E.Message);
      ANSIToOem(Buffer,Buffer); // convert codepage for console
      writeln(Buffer);
      writeln('Click <ENTER> to close');
      readln;
      halt;
    end;
  end;
  Fitter.Expression:=0; // polynomial fitting
  Fitter.ParamCount:=4; // number of terms in the polynom
  Fitter.X:=X;
  Fitter.Y:=Y;
  if Fitter.LinearFit then
  begin // print results
    writeln('Fitter.ResultCode: ', Fitter.ResultCode);
    writeln('Fitter.Deviation: ', Fitter.Deviation);
    P:=Fitter.Parameters;
    for I:=0 to Fitter.ParamCount-1 do
    writeln('Parameters[', I, ']=', P[I]);
  end else
    writeln('Fitting error #', Fitter.ResultCode);
  // release Fitter
  // Fitter:=Unassigned;
  // OleUninitialize;
  // wait to close application
  writeln('Click <ENTER> to close');
  readln;
end.
