' Use this file with weight.dat to test weight feature of LM fitter.
' It will automatically search and load data file, fit and display result.
' This script must be executed under Windows Scripting Host.

Option Explicit

Dim Fso, MyFile, Fitter, I, S, A, X, Y, W

set Fso=CreateObject("Scripting.FileSystemObject")
set MyFile=Fso.OpenTextFile(Replace(WScript.ScriptFullName, "vbs", "dat"))

ReDim X(300) ' init arrays size (need for future ReDim Preserve)
ReDim Y(300) ' the number of elements must be sufficient to read all data!
ReDim W(300)

I=0 ' init array index
Do While MyFile.AtEndOfStream<>True ' read data file
  S=Trim(MyFile.ReadLine) ' leading/trailing spaces cause empty A entries!
  A=Split(S, " ")
  if (UBound(A)=2) and (I<=UBound(X)) then
    X(I)=A(0)
    Y(I)=A(1) ' WARNING: if local decimal number separator is ',' the type
    W(I)=A(2) ' of X,Y,W elements will be STRING!!! and the script fails.
    I=I+1
  end if
Loop
MyFile.Close

ReDim Preserve X(I-1) ' size of data vectors calculated by array size
ReDim Preserve Y(I-1)
ReDim Preserve W(I-1)

set Fitter=CreateObject("Fitter.DMFitter") ' create and init fitter object

Fitter.X=X
Fitter.Y=Y
Fitter.Weight=W
Fitter.WeightType=1
Fitter.Expression="p1+p2*cx+p3*cx^2"
Fitter.ParamCount=3
Fitter.Parameters=Array(1,1,1)
Fitter.Sigmas=Array(0,0,0)
Fitter.Options=Array(1e-7, 1e-7, 0)
Fitter.Iterations=30
if Fitter.LMFit then
  S="Deviation: " & Sqr(Fitter.Deviation) & vbCrLf
  A=Fitter.Parameters
  for I=0 to UBound(A)
    S=S & "Parameters(" & I+1 & "): " & A(I) & vbCrLf
  next
  WScript.Echo S
else
  WScript.Echo "Error code: " & Fitter.ResultCode
end if

